--- //depot/vendor/freebsd/src/sys/rpc/rpcclnt.c	2005/03/19 01:22:25
+++ //depot/user/rwatson/netperf/sys/rpc/rpcclnt.c	2005/06/01 10:10:04
@@ -145,7 +145,7 @@
 
 /* XXX ugly debug strings */
 #define RPC_ERRSTR_ACCEPTED_SIZE 6
-char *rpc_errstr_accepted[RPC_ERRSTR_ACCEPTED_SIZE] = {
+const char *rpc_errstr_accepted[RPC_ERRSTR_ACCEPTED_SIZE] = {
 	"",			/* no good message... */
 	"remote server hasn't exported program.",
 	"remote server can't support version number.",
@@ -154,13 +154,13 @@
 	"remote error.  remote side memory allocation failure?"
 };
 
-char *rpc_errstr_denied[2] = {
+const char *rpc_errstr_denied[2] = {
 	"remote server doesnt support rpc version 2!",
 	"remote server authentication error."
 };
 
 #define RPC_ERRSTR_AUTH_SIZE 6
-char *rpc_errstr_auth[RPC_ERRSTR_AUTH_SIZE] = {
+const char *rpc_errstr_auth[RPC_ERRSTR_AUTH_SIZE] = {
 	"",
 	"auth error: bad credential (seal broken).",
 	"auth error: client must begin new session.",
@@ -360,7 +360,7 @@
 		RPC_RETURN(EFAULT);
 	}
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 	/* create the socket */
 	rpc->rc_so = NULL;
@@ -618,7 +618,7 @@
 {
 	struct socket  *so;
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 	if (rpc->rc_so) {
 		so = rpc->rc_so;
@@ -669,7 +669,7 @@
 #endif
 	int error, soflags, flags;
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 	if (rep) {
 		if (rep->r_flags & R_SOFTTERM) {
@@ -754,7 +754,7 @@
 #endif
 	int error, sotype, rcvflg;
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 	/*
 	 * Set up arguments for soreceive()
@@ -1439,6 +1439,7 @@
 		 * Set r_rtt to -1 in case we fail to send it now.
 		 */
 		rep->r_rtt = -1;
+		SOCKBUF_LOCK(&so->so_snd);
 		if (sbspace(&so->so_snd) >= rep->r_mreq->m_pkthdr.len &&
 		    ((rpc->rc_flag & RPCCLNT_DUMBTIMR) ||
 		     (rep->r_flags & R_SENT) ||
@@ -1473,6 +1474,7 @@
 				rep->r_rtt = 0;
 			}
 		}
+		SOCKBUF_UNLOCK(&so->so_snd);
 	}
 	splx(s);
 
--- //depot/vendor/freebsd/src/sys/security/mac/mac_net.c	2005/07/05 23:40:38
+++ //depot/user/rwatson/netperf/sys/security/mac/mac_net.c	2005/07/19 11:47:08
@@ -271,6 +271,11 @@
 	MAC_PERFORM(copy_ifnet_label, src, dest);
 }
 
+/*
+ * XXXRW: Need to use a routine to copy the ifnet label while holding the
+ * ifnet mutex, similar to sockets, pipes, vnodes, et al, to avoid holding
+ * the mutex over the copyin/copyout.
+ */
 static int
 mac_externalize_ifnet_label(struct label *label, char *elements,
     char *outbuf, size_t outbuflen)
@@ -282,6 +287,9 @@
 	return (error);
 }
 
+/*
+ * XXXRW: See comment for mac_externalize_ifnet_label().
+ */
 static int
 mac_internalize_ifnet_label(struct label *label, char *string)
 {
--- //depot/vendor/freebsd/src/sys/sys/pcpu.h	2005/04/26 17:10:17
+++ //depot/user/rwatson/netperf/sys/sys/pcpu.h	2005/06/01 10:10:04
@@ -85,6 +85,7 @@
 #ifndef curthread
 #define	curthread	PCPU_GET(curthread)
 #endif
+#define	curcpu		PCPU_GET(cpuid)
 
 /*
  * MI PCPU support functions
--- //depot/vendor/freebsd/src/sys/sys/socketvar.h	2005/07/09 12:25:21
+++ //depot/user/rwatson/netperf/sys/sys/socketvar.h	2005/07/19 11:47:08
@@ -356,6 +356,7 @@
 		SOCK_UNLOCK(so);					\
 		ACCEPT_UNLOCK();					\
 	}								\
+	so = NULL;							\
 } while (0)
 
 #define	sotryfree(so) do {						\
@@ -367,6 +368,7 @@
 		SOCK_UNLOCK(so);					\
 		ACCEPT_UNLOCK();					\
 	}								\
+	so = NULL;							\
 } while(0)
 
 /*
